<?php
	error_reporting(E_ALL);
	require 'settings.php';

	function cleanstring($string)
	{
		return iconv('UTF-8', 'ASCII//TRANSLIT//IGNORE', strtolower($string));
	}

	function downloadall()
	{
		$zip = new ZipArchive();
		$zip_name = 'bbn.zip';
		$zip->open($zip_name,  ZipArchive::CREATE);
		foreach($_SESSION['index'] as $path)
		{
			if (!str_ends_with($path, '.del'))
			{
				$path = $path . '.md';
				if (file_exists($path))
				{
					$zip->addFile($path, basename($path));
				}
			}
		}
		$zip->close();

		header('Content-disposition: attachment; filename=' . $zip_name);
		header('Content-type: application/zip');
		readfile($zip_name);

		unlink($zip_name);
	}

	function savenote($title, $content)
	{
		global $dir;
		$path = $dir . '/' . $title;
		$lastchanged = filemtime($path . '.md');
		$previous = $_POST['lastchanged'];
		if ((int)$lastchanged > (int)$previous)
		{
			$tempcontent = file_get_contents($path . '.md');
			if ($tempcontent != $content)
			{
				$temptitle = $title . '_conflict_' . $lastchanged;
				file_put_contents($dir . '/' . $temptitle . '.md', $tempcontent);
				array_unshift($_SESSION['index'], $dir . '/' . $temptitle);
			}
		}
		file_put_contents($path . '.md', $content);
		removefromindex($title);
		array_unshift($_SESSION['index'], $path);
	}

	function removefromindex($title)
	{
		global $dir;
		$key = array_search($dir . '/' . $title, $_SESSION['index']);
		if ($key !== FALSE)
		{
			array_splice($_SESSION['index'], $key, 1);
		}
	}

	function downloadnote($path)
	{
		header('Content-disposition: attachment; filename=' . basename($path));
		header('Content-type: text/markdown');
		readfile($path);
	}

	function linksdiv($content)
	{
		$divcontent = '<div class="grey">';
		$links = array();
		if (preg_match_all('/\[\[(.*)\]\]/', $content, $links, PREG_SET_ORDER))
		{
			foreach($links as $link)
			{
				$divcontent .=  '<div>
				<a href="index.php?open=true&param=' . urlencode($link[1]) . '">' . $link[1] . '</a>
				</div>';
			}
		}
		$links = array();
		if (preg_match_all('/(https?:.*)\b/', $content, $links, PREG_SET_ORDER))
		{
			foreach($links as $link)
			{
				$divcontent .=  '<div>
				<a target="_blank" href="' . $link[1] . '">' . $link[1] . '</a>
				</div>';
			}
		}
		$divcontent .= '</div>';
		return $divcontent;
	}

	function computepreview($title, $content)
	{
		require 'libs/Parsedown.php';
		$pos = 0;
		if (str_starts_with($content, '---'))
		{
			$pos = strpos($content, '---', 3) + 3;
		}
		$Parsedown = new Parsedown();
		$Parsedown->setBreaksEnabled(true);
		$preview = $Parsedown->text('# ' . $title . "\r\n" . substr($content, $pos));
		return $preview;
	}

	// authent
	if ($password && (!isset($_SERVER['PHP_AUTH_PW']) || $_SERVER['PHP_AUTH_PW'] != $password))
	{
		header('WWW-Authenticate: Basic realm="bbn"');
		header('HTTP/1.0 401 Unauthorized');
		echo '<p>Access denied.</p></body></html>';
		exit;
	}

	// reindex if needed
	session_start();
	if (!isset($_SESSION['index']) || isset($_GET['reindex']) || empty($_SESSION['index']))
	{
		$files = glob($dir . '/*');
		usort($files, function($a, $b)
		{
			return filemtime($b) - filemtime($a);
		});
		$_SESSION['index'] = array_map(fn($value): string => str_replace('.md', '', $value), $files);
	}
?>